package com.flyfish.framework.r2dbc.config.callback;

import com.flyfish.framework.domain.base.Domain;
import lombok.Setter;
import org.reactivestreams.Publisher;
import org.springframework.beans.factory.ObjectProvider;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.context.ApplicationContextAware;
import org.springframework.data.mapping.PersistentEntity;
import org.springframework.data.r2dbc.core.R2dbcEntityOperations;
import org.springframework.data.r2dbc.mapping.event.AfterConvertCallback;
import org.springframework.data.relational.core.sql.SqlIdentifier;
import org.springframework.lang.NonNull;
import reactor.core.publisher.Mono;

public class ReferenceR2dbcCallback implements AfterConvertCallback<Domain>, ApplicationContextAware {

    @Setter
    private ApplicationContext applicationContext;

    @Setter(onMethod_ = @Autowired)
    private ObjectProvider<R2dbcEntityOperations> entityOperations;

    @Override
    @NonNull
    public Publisher<Domain> onAfterConvert(@NonNull Domain entity, @NonNull SqlIdentifier table) {
        // 遍历fields，找到要注入的数据
        entityOperations.getIfAvailable();
        return Mono.just(entity);
    }
}
